-- ExCANOOP.ex

include EuCANOOP.e

constant TRUE = 1, FALSE = 0,
         prefix = {"=","?","if","while"}

function in(object obj,sequence seq)
    integer b
    b = FALSE
    for i = 1 to length(seq) do
        if equal(obj,seq[i]) then
            b = TRUE
        end if
    end for
    return b
end function

function split(string st, string delim)
	sequence ret
	object pos
	ret={}
	
	while 1 do
		pos = match(delim, st)
		if pos then
			ret = append(ret, st[1..pos-1])
			st = st[pos+length(delim)..length(st)]
		else
			exit
		end if
	end while
	ret = append(ret, st)
	
	return ret
end function

function separate(string prefix)
	integer i
	string first
	bool space
	i = 0
	first = EMPTY_STRING
	space = TRUE
	while space do
		i += 1
		if prefix[i] = 32 then
			first &= " "
		elsif prefix[i] = 9 then
			first &= 9
		else
			space = FALSE
		end if
		if i = length(prefix) then
			space = FALSE
		end if
	end while
	return {first,prefix[i..$]}
end function

include get.e
constant fileName = prompt_string("What file do you want to process? "),
         fileHandle = open(fileName,"r"),
		 pathName = split(fileName,".")
string extension 
    extension = pathName[2]
	extension[1] = 'e'
constant euFileName = pathName[1] & '.' & extension,
         outputFileHandle = open(euFileName,"w"),
         EOF = -1

integer lines lines = 0
integer found found = 0
string outline outline = ""

object line

procedure vanilla()
	puts(outputFileHandle,line)
end procedure

sequence test, one, func, parms, prefx, proc, args, args2
string pre, fun
integer pref, fn
while 1 do
    line = gets(fileHandle)
	found = 0
	outline = ""
	pre = ""
	pref = FALSE
    if (atom(line) and line = EOF) then
    	exit
 	else
		if length(line) >2 then
			test = separate(line)
			if length(test[1]) = length(line) - 1 then
				-- "blank" line
				vanilla()
			elsif equal(test[2][1..2],"--") then
				-- comment
				vanilla()
			else
	 			found = find(':',line)
				if found then
					if line[found+1] = ':' then
						-- non-comment line containing double-colon syntax
						test = split(line,"::")
						for i = 1 to length(prefix) do
							one = split(test[1],prefix[i])
							if length(one) > 1 then
								pref = TRUE
								pre = prefix[i]
							end if
						end for
						if pref then
							-- function Method
							one = split(test[1],pre)
							outline = one[1] &
									  pre & 
									  " " &
									  "MethodFunc("
							func = split(test[2],"(")
							fun = one[2]
							fn = length(func)
							if fn > 1 then
								--straight Method usage
								parms = split(func[2],")")
								outline &= fun[2..$] &
								           ",\"" &
								           func[1] &
										   "\",{" &
										   parms[1] &
										   "})" &
										   parms[2][1..$-1]
							else
								-- accessor Method invocation
								outline &= fun &
								           ",\"" &
								           "Get\",{\"" &
										   func[1][1..$-1] &
										   "\"})"
							end if
						else
							-- procedure Method
							proc = split(test[2],"(")
							args = split(proc[2],")")
							prefx = separate(test[1])
							outline = prefx[1] &
							          "MethodProc(" &
									  prefx[2] &
									  ",\"" &
									  proc[1] &
									  "\",{" &
									  args[1]
		 					if length(args) = 1 then
								args2 = split(proc[3],")")
				  				outline &= '('
										 & args2[1]
										 & ')'
								if length(args2) > 1 then
									outline &= args2[2]
								end if
								outline &= "})"
							else
								outline &= "})"
							end if
						end if
						puts(outputFileHandle,outline & '\n')
					end if	
				else
					-- line containing single colon
					vanilla()
				end if
			end if
		else
			-- ordinary Euphoria code
			vanilla()
		end if
	end if
end while
close(outputFileHandle)

-- Execute

printf(2,"\n** Euphoria source file: %s created. **",{euFileName})
if getc(0) then end if

--if find('x',extension) then
	--system("start " & euFileName,0)
--end if

if getc(0) then end if
