--------------------------------------------------------------------------------
-- Name:         PE01 - Illustration of PE01 for a DOS environment

-- Version:      .ex
--               (uses EuCANOOP library)

-- Author:       C. A. Newbould
-- Created:      May 2008
-- Amended:      November 2008 (for EuCANOOP 3)

-- Intro:
-- Notes:        Based on EuCANOOP library.
--------------------------------------------------------------------------------

-- Include files

--------------------------------------------------------------------------------
-- Include: Data.e
-- Location: this folder
-- Called Routines: inherited
--------------------------------------------------------------------------------
include Data.e

--------------------------------------------------------------------------------
-- Include: get.e
-- Location: included via IO.e, via Data.e
-- Called Routine: prompt_string.
--------------------------------------------------------------------------------

-- Constants

--------------------------------------------------------------------------------
-- Name: yes
-- Value: 1
--------------------------------------------------------------------------------
    constant yes = 1,

--------------------------------------------------------------------------------
-- Name: no
-- Value: 0
--------------------------------------------------------------------------------
             no = 0

--------------------------------------------------------------------------------

-- Local Service routines

--------------------------------------------------------------------------------
-- Function: enquire
-- Usage:    enquire(string prompt)
-- Parameter: prompt - a prompt string for the user to enter 'y' or 'n'
-- Return value: yes(1) or no(0)
-- Scope: local
--------------------------------------------------------------------------------
    
    function enquire(string prompt)
        string response
        response = prompt_string(prompt & " (y or n)? ")
        if response[1] = 'y' then
            return yes
        else
            return no
        end if
    end function
    
--------------------------------------------------------------------------------
-- Procedure: main
-- Usage:  main()
-- Purpose: pulls together the various steps of the program
-- Scope: local
-- Note: this approach stylistic, not essential
--------------------------------------------------------------------------------
    procedure main()
        sequence fileName
        Instance myData
        fileName = prompt_string("Program PE01.\n\n" & 
                                 "What file do you want to analyse? ")
        myData = Data(fileName,"r")
        MethodProc(myData,"GetParameters",{
                 prompt_string("Run name to identify the data in the output: "),
                 enquire("Does the data start with labels"),
                 prompt_string("What delimits the data in each record? "),
                 enquire("Do you want matrix output")
                  })
        MethodProc(myData,"Scan",{})
        MethodProc(myData,"Close",{})
        MethodProc(myData,"Report",{})
        MethodProc(StdOut,"PrintFormat",{"\n** Output send to file: %s **\n\n",
                           {fileName[1..$-3] & "res"}})
        if MethodFunc(myData,"Get",{"SPSS_OUTPUT"}) then
            MethodProc(myData,"MatrixOutput",{})
            MethodProc(StdOut,"PrintFormat",
                              {"** Matrix sent to  file: %s **\n\n",
                               {fileName[1..$-3] & "mat"}})
        end if
        pause("--Press ENTER to close window--")
    end procedure

--------------------------------------------------------------------------------

-- Execution

--------------------------------------------------------------------------------
main()

--------------------------------------------------------------------------------

-- end of PE01.ex

--------------------------------------------------------------------------------